// MemDebugStats.h : Interface of the heap memory-dump library
// Author: Juan Carlos "JCAB" Arvalo Baeza <mailto:jcab@roningames.com>
// (C) 2000-2001 Ronin Entertainment <http://www.roningames.com>
// You may use this as you like, as long as you don't remove the copyright.

#ifndef MemDebugStats_H_INCLUDED
#define MemDebugStats_H_INCLUDED
#pragma once

#include <CrtDbg.h>

struct MemDebugSnapshot {
	_CrtMemState memState;
	int *hookedBlock;
	MemDebugSnapshot(): hookedBlock(0) {}
	~MemDebugSnapshot() { delete hookedBlock; }
};

void GetMemSnapshot(MemDebugSnapshot &snap);
void DumpMemStats(MemDebugSnapshot &snap, const char *file, unsigned int line);
void DumpMemStats(const char *file, unsigned int line);
void DumpShortMemStats(const char *file, unsigned int line);

#define DUMP_MEM_STATS(s)			DumpMemStats((s), __FILE__, __LINE__)
#define DUMP_CURRENT_MEM_STATS()	DumpMemStats(__FILE__, __LINE__)
#define DUMP_SHORT_MEM_STATS()		DumpShortMemStats(__FILE__, __LINE__)

#define DBG_NEW new(_NORMAL_BLOCK, __FILE__, __LINE__)

#endif
